# spirals.py
#
# Sample Webots controller file for driving the
# underactuated spirals device.
#
# No copyright, 2020-2022, Garth Zeglin.  This file is
# explicitly placed in the public domain.

print("loading Penguin.py...")

# Import the Webots simulator API.
from controller import Robot

# Import the standard Python math library.
import math

print("Penguin.py waking up...")

# Define the time step in milliseconds between
# controller updates.
EVENT_LOOP_DT = 20

# Request a proxy object representing the robot to
# control.
robot = Robot()

# Fetch handle for the 'base' joint motor.
FeetBodyMotor = robot.getDevice('FeetBodyMotor')
FeetBodyPos = robot.getDevice('FeetBodyPos')
BodyHeadMotor = robot.getDevice('BodyHeadMotor')
BodyHeadPos = robot.getDevice('BodyHeadPos')
BodyLwingMotor = robot.getDevice('BodyLwingMotor')
BodyLwingPos = robot.getDevice('BodyLwingPos')
BodyRwingMotor = robot.getDevice('BodyRwingMotor')
BodyRwingPos = robot.getDevice('BodyRwingPos')

# Run an event loop until the simulation quits, or until loop breaks
# indicated by the step function returning -1.

while robot.step(EVENT_LOOP_DT) != -1:

    # Read simulator clock time.
    t = robot.getTime()
    if t > 18:
        break
    elif t > 7:
        BodyHeadMotor.setPosition(0)
    
    elif t > 6:
        BodyHeadMotor.setPosition(-0.75)
    elif t > 4:
        BodyHeadMotor.setPosition(0.75)

print('now to automated movement')
    
while robot.step(EVENT_LOOP_DT) != -1:

    # Read simulator clock time.
    t = robot.getTime()

    # move arms up and down
    theta = -2
    BodyLwingMotor.setPosition(theta)
    BodyRwingMotor.setPosition(theta)
    
    # move body from side to side
    thetaBody = 2 * math.sin(3*t)
    FeetBodyMotor.setPosition(thetaBody)
    #BodyHeadMotor.setPosition(thetaBody)
    